<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:fn="http://www.w3.org/2005/xpath-functions"
                xmlns:xfi="http://www.xbrl.org/2008/function/instance"
                xmlns:xbrli="http://www.xbrl.org/2003/instance"
                xmlns:xbrldi="http://xbrl.org/2006/xbrldi"
                version="2.0">

    <xsl:function name="xfi:unit-numerator" as="element(xbrli:measure)+" >
        <xsl:param name="xbrli.unit" as="element(xbrli:unit)" />

        <xsl:sequence select="$xbrli.unit/xbrli:measure union $xbrli.unit/xbrli:unitNumerator/xbrli:measure" />
    </xsl:function>

    <xsl:function name="xfi:unit" as="element(xbrli:unit)?">
        <xsl:param name="fact" as="element()" />

        <xsl:variable name="unit-id" select="$fact/@unitRef" />
        <xsl:variable name="unit-element" select="$fact/ancestor::xbrli:xbrl/xbrli:unit[@id = $unit-id]" />

        <xsl:sequence select="$unit-element" />
    </xsl:function>

</xsl:stylesheet>